{% extends "base.html" %}
{% load static %}
{% load getattr %}
{% load keyvalue %}
{% block title %}
    MiCorr | {{ artefact.artefact_verbose_description_short }}
{% endblock title %}
{% block sidemenu %}
    <div class="c3 hidden-print" id="sidemenu">
        <!-- no-active-hilight : do not highlight the "active" node of the menu. It is difficult for the affix to work when elements in the page are close one to the other (i.e. folded elements), therefore, it is less confusing to NOT hilight the .active nodes of the menu -->
       {% if form %}
        <div style="position:fixed; width: 263px; top:86px">
          <input form="main-form" class="btn btn-default btn-lg" type="submit" value="Save">
        </div>
        {% endif %}
        <div class="sidemenu-container active-highlight">
            <ul class="nav smooth-scroll"> <!-- smooth-scroll to the element in the page instead of jumping -->
                {% for sections in section_groups %}
                    {% for s in sections %}
                        {% if forloop.first %}
                            <li>
                                <a href="#title{{ forloop.parentloop.counter }}">
                                    {{ s.section.template.title }}</a>
                            {% if forloop.revcounter0 %}
                                <ul class="nav subnav">
                            {% endif %}
                        {% else %}
                                    <li>
                                        <a href="#title2{{ s.section.template.order }}">
                                            {{ s.section.template.title }}</a>
                                    </li>
                        {% endif %}
                    {% if forloop.last %}
                        {% if forloop.counter > 1 %}
                                </ul>
                        {% endif %}
                            </li>
                    {% endif %}
                    {% endfor %}
                {% endfor %}
            </ul>
        </div>
    </div>
{% endblock sidemenu %}

{% block content %}
    {% load terms %}
    <!-- save Modal alert-->
    <div id="saveModal" class="modal fade" role="dialog" data-backdrop="true">
        <div class="modal-dialog">
            <div class="modal-content">
                <div id="save-modal-alert" class="alert" role="alert" style="margin-bottom: 0px;">
                    <a class="close" data-dismiss="modal" href="#">&times;</a>
                    <p></p>
                </div>
            </div>
        </div>
    </div>
    <div class="c9 print-width100">
        <h1 class="hidden-print">{{ object.artefact_verbose_description_short }}</h1>
        <a class="hidden-screen" href="{% url 'artefacts:artefact-detail' object.id %}">
            <h1> {{ object.artefact_verbose_description_short }}</h1>
        </a>

        {% if form and form.instance.pk%}
        {% if token_id %}
            <form id="main-form"  action="{% url 'artefacts:collaboration-update' token_id=token_id %}" method="post">
        {% else %}
            <form id="main-form" action="{% url 'artefacts:artefact-update' form.instance.pk %}" method="post">
        {% endif %}
        {% csrf_token %}
    {% endif %}
        {% if form.errors %}
            {% for field in form %}
                {% for error in field.errors %}
                    <div class="alert alert-error">
                        <strong>{{ field.name }} {{ error|escape }}</strong>
                    </div>
                {% endfor %}
            {% endfor %}
            {% for error in form.non_field_errors %}
                <div class="alert alert-error">
                    <strong>{{ field.name }} {{ error|escape }}</strong>
                </div>
            {% endfor %}
        {% endif %}
        {%  if artefact_editor_goal %}
        <div id="accordionN0" aria-multiselectable="true">
            <div class="row accordion-title1" id="title_artefact_help">
                <a class="line" data-toggle="collapse" data-parent="#accordionN0"
                   href="#content0" aria-expanded="true"
                   aria-controls="content0">{{ artefact_editor_goal.title|safe}}</a>
            </div>
            <div class="row accordion-content1 collapse in" id="content0"
                 aria-labelledby="title0">
                <div class="c10">
                {{ artefact_editor_goal.intro|safe}}
                </div>
            </div>
        </div>
            <div class="row">
                <div class="c12">
                </div>
            </div>
        {% endif %}
        {% for field in authors_fieldset %}
              <div class="row">
                <div class="c2" title="{{ field.help_text}}">
                    {{ field.label_tag }}
                </div>
                <div class="c10">
                {% if form %}
                    <p title="{{ form_instructions | keyvalue:field.name |safe}}">{{ field }}</p>
                    <p><i>{{ form_instructions | keyvalue:field.name |safe}}</i></p>
                {% else %}
                    {% if field.name == 'name' %}
                        <p>{{ authors_fieldset.form.instance.object | getattr:field.name |safe}}</p>
                    {% else %}
                        <p>{{  object.get_authors }}</p>
                    {% endif %}
                {% endif %}
                </div>
              </div>
        {% endfor %}
        {% block actions %}
            {% if not form %}
            <div class="row hidden-print">
                <div class="c12 ">
                    <a class="btn btn-success" href="contact_author">
                        <i class="fa fa-envelope"></i> Contact the author</a>
                    <a class="btn btn-success" href="{% url 'artefacts:share_artefact_with_friend' object.id %}">
                        <i class="fa fa-share-alt"></i> Share </a>
                    <a class="btn btn-success" href="{% url 'artefacts:artefact-detail-print' object.id %}">
                        <i class="fa fa-print"></i>Print </a>

                </div>
            </div>
            <div class="row hidden-screen">
                <div class="c2">
                    <label>Url</label>
                </div>
                <div class="c10">
                    <a href="{% url 'artefacts:artefact-detail' object.id %}">{% url 'artefacts:artefact-detail' object.id %}</a>
                </div>
            </div>
            {% endif %}
        {% endblock actions %}
        <div id="accordionN1" aria-multiselectable="true">
        {% for sections in section_groups %}
            {% for s in sections %}
                    {%  if forloop.first %}
                     <div class="row accordion-title1" id="title{{forloop.parentloop.counter}}">
                        <a class="line" data-toggle="collapse" data-parent="#accordionN1" title="{{ s.section.template.title_title }}"
                           href="#content{{ s.section.template.order }}" aria-expanded="true"
                           aria-controls="content{{ s.section.template.order }}">{{ s.section.template.title }}</a>
                    </div>
                     <div class="row accordion-content1 collapse in" id="content{{ s.section.template.order }}"
                         aria-labelledby="title{{ s.section.template.order }}">
                    {% else %}
                     <!--section level 2-->
                         {% if forloop.counter == 2 %}
                          <div class="line">
                            <div id="accordionN{{forloop.parentloop.counter|add:1}}" aria-multiselectable="true">
                         {% endif %}
                            <!--ZONES-->
                                <div class="row accordion-title2" id="title2{{ s.section.template.order }}">
                                    <a class="line" data-toggle="collapse" data-parent="#accordionN{{forloop.parentloop.counter|add:1}}" href="#content2{{ s.section.template.order }}"
                                    aria-expanded="true" aria-controls="content2{{ s.section.template.order }}" title="{{ s.section.template.title_title }}">
                                        {{s.section.template.title}}</a>
                                </div>
                                <div class="row accordion-content2 collapse in" id="content2{{ s.section.template.order }}" aria-labelledby="title2{{ s.section.template.order }}">
                    {% endif %}
                {% if s.section.template.has_content %}
                    <div class="line palebox">
                    <div class="row">
                        <div class="c11">
                            {% if form %}
                                <textarea class="tinymce" data-mce-conf="{{ s.content_mce_conf }}" name="s{{s.section.template.order}}_content" id="s{{s.section.template.order}}_content">{{ s.section.content }} </textarea>
                                {{ s.section.template.content_help_text|safe }}
                            {% else %}
                                {% filter replace_terms %}
                                <p>{{ s.section.content|safe }}</p>
                                {% endfilter %}
                            {% endif %} {# form #}
                        </div>
                                {% if token_id %}
                                    <div class="c1">
                                        <div class="pull-right">
                                            <a href="#comment_{{s.section.template.order}}_content" data-toggle="collapse" aria-expanded="false"
                                               aria-controls="#comment_{{s.section.template.order}}_content">
                                            {% if field_comments|keyvalue:s.section.id %}
                                                <span class="iconover ">{{ field_comments|keyvalue:s.section.id|length }}
                                                    <i class="fa fa-comment {% if field_comments|keyvalue:s.section.id %} redicon {% endif %}"></i>
                                                </span>
                                                {%  else %}
                                                <i class="hidden-iconover fa fa-comment"></i>
                                                {% endif %}
                                            </a>
                                        </div>
                                    </div>
                                {% endif %} {# token_id #}
                    </div>
                                {% if token_id %}
                                    <form action="{% url 'artefacts:collaboration-comment' token_id=token_id section_id=s.section.id field='' %}"
                                          id="form_{{ s.section.id }}" method="post">
                                        {% csrf_token %}
                                        <div class="row collapse" id="comment_{{ s.section.template.order }}_content"
                                             aria-expanded="false">
                                            <div class="line middlebox">
                                                {% if field_comments|keyvalue:s.section.id %}
                                                    {% with values=field_comments|keyvalue:s.section.id %}
                                                        {% include "./comments_show.html" %}
                                                    {% endwith %}
                                                {% endif %}
                                                {% with form=comment_form %}
                                                    {% include "./comment_form.html" %}
                                                {% endwith %}
                                            </div>
                                        </div>
                                    </form>
                                {% endif %} {# token_id #}
                    </div>
                {% endif %} {# has_content #}
                {% if s.section.template.has_images %}
                    <div class="line lightbox">
                        {% if form %}
                        <div class="row">
                            <div  class="c12" id="image_section_{{ s.section.id }}">
                        {% endif %}{# form #}
                            {% for image in s.section.image_set.all %}
                                <div class="row">
                                {% if image.image %}
                                    <div class="c6">
                                        <a href="{{ image.image.url }}" class="image-popup">
                                            <img src="{{ image.image.url }}" class="img-responsive">
                                        </a>
                                        {% if image.credit_url %}
                                            <i>Credit </i>
                                            <a href="{{ image.credit_url  | safe}}" target="_blank">
                                                <i>{{ image.credit | safe }}</i>
                                            </a>
                                        {% else %}
                                            <i>Credit {{ image.credit | safe }}</i>
                                        {% endif %}
                                    </div>
                                    <div class="c6">
                                        <p><a name="fig1"></a>
                                            {% filter replace_terms %}
                                            {{ image.legend | safe }}
                                            {% endfilter %}
                                            {% if form %}
                                            <a onclick="window.open('{% url 'artefacts:image-update' section_id=s.section.id pk=image.id %}', 'newwindow', 'height=450px, width=700px, scrollbars=1');"><i class="fa fa-pencil"></i></a>
                                            <a onclick="window.open('{% url 'artefacts:image-delete' image.id %}', 'newwindow', 'height=450px, width=700px, scrollbars=1');"><i class="fa fa-trash"></i></a>
                                            {% endif %}
                                        </p>
                                    </div>
                                {% endif %}
                                </div>
                            {% endfor %}
                        {% if form %}
                            </div>
                            <div class="c9">
                                <p> <!-- Upload Photos -->
                                    <a class="add-another" id="image_add_"{{ s.section.id }}
                                       title=" {{ s.section.template.images_title|safe }}"
                                       onclick="window.open('{% url 'artefacts:image-create' section_id=s.section.id %}', 'newwindow', 'height=450px, width=700px, scrollbars=1');">
                                        <span class="glyphicon glyphicon-plus"></span>
                                    </a>
                                </p>
                            </div>
                        </div>
                        {{ s.section.template.images_help_text|safe }}
                        {% endif %} {# form #}
                    </div>
                {%  endif %} {# has_images #}
                {% if s.section.template.has_stratigraphies %}
                    {% if False %}
                    <div class="row accordion-title2" id="title2{{ s.section.template.order }}2">
                        <a class="line" data-toggle="collapse" data-parent="#accordionN{{forloop.parentloop.counter|add:1}}" href="#content2{{ s.section.template.order }}"
                            aria-expanded="true" aria-controls="content2{{ s.section.template.order }}2">Stratigraphies</a>
                    </div>
                    <div class="row accordion-content2 collapse in" id="content2{{ s.section.template.order }}2" aria-labelledby="title2{{ s.section.template.order }}2">
                    {% else %}
                    <div class="line palebox">
                    {% endif %}
                    <div id="stratigraphy_section_{{ s.section.id }}">
                    {% with section=s.section %}
                        {% include "artefacts/stratigraphy.html" %}
                    {% endwith %}
                    </div>
                    {% if form %}
                        <div class="c9">
                            <p>
                                <a class="add-another" id="stratigraphy_add"
                                   title=" {{ s.section.template.stratigraphies_title|safe }}"
                                   onclick="window.open('{% url 'artefacts:stratigraphy-list' s.section.id %}', 'newwindow', 'height=450px, width=700px, scrollbars=1');">
                                    <span class="glyphicon glyphicon-plus"></span>
                                </a>
                            </p>
                        </div>
                        {{ s.section.template.stratigraphies_help_text|safe }}
                    {%  endif %} {# form #}
                </div>
                {% endif %} {# has_stratigraphies #}
                {% if s.form %}
                    <div class="line lightbox">
                                  {% for field in s.fieldset %}
                                      <div class="row">
                                        <div class="c3" title="{{ field.help_text}}">
                                            {{ field.label_tag }}
                                        </div>
                                        <div class="c9">
                                        {% if form %}
                                            <p title="{{ form_instructions | keyvalue:field.name |safe}}">{{ field }}</p>
                                            <p><i>{{ form_instructions | keyvalue:field.name |safe}}</i></p>
                                        {% else %}
                                             {% filter replace_terms %}
                                            <p>{{ s.form.instance | getattr:field.name |safe}}</p>
                                            {%  endfilter %}
                                        {% endif %}
                                        {% if token_id %}
                                            <a href="#{{ field.auto_id }}_comment" data-toggle="collapse"
                                               aria-expanded="false" aria-controls=#{{ field.auto_id }}_comment">
                                                {% if field_comments|keyvalue:field.auto_id %}
                                                    <span class="iconover"> {{field_comments|keyvalue:field.auto_id|length}} <i class="fa fa-comment redicon "></i></span>
                                                {% else %}
                                                    <i class="hidden-iconover fa fa-comment"></i>
                                                {% endif %}

                                            </a>
                                        {% endif %}
                                        </div>
                                      </div>
                                      {% if token_id %}
                                      <div class="row collapse" id="{{ field.auto_id }}_comment"  aria-expanded="false">
                                          {% url 'artefacts:collaboration-comment' token_id=token_id section_id=s.section.id field=field.auto_id as form_action_url %}

                                          <form id="form_{{ s.section.id }}_{{ field.auto_id }}" action="{{ form_action_url }}" method="post">
                                          {% csrf_token %}

                                              <div class="line middlebox">

                                              {% for key, values in field_comments.items %}
                                                  <p>{{key}}</p>
                                              {% endfor %}

                                              {% if field_comments|keyvalue:field.auto_id %}
                                                {% with values=field_comments|keyvalue:field.auto_id%}
                                                    {% include "./comments_show.html" %}
                                                  {% endwith %}
                                              {% endif %}
                                                  {% with form=comment_form %}
                                                      {% include "./comment_form.html" %}
                                                  {% endwith %}
                                              </div>
                                          </form>
                                      </div>
                                      {% endif %}
                                {% endfor %}
                        </div>
                {% endif %}
                {% if s.section.template.has_complementary_information %}
                    {% if form or s.section.complementary_information %}
                    <div class="line palebox">
                        <h4 class="underline">Complementary information</h4>
                    {% endif %}
                     {% if form %}
                         <textarea class="tinymce" data-mce-conf="{{ s.complementary_information_mce_conf}}"name="s{{s.section.template.order}}_complementary_information" id="s{{s.section.template.order}}_complementary_information">{{ s.section.complementary_information }}</textarea>
                         {{ s.section.template.complementary_information_help_text|safe }}
                     {% elif s.section.complementary_information %}
                         {% filter replace_terms %}
                         <p>{{ s.section.complementary_information|safe }}</p>
                         {% endfilter %}
                    {% endif %}
                    {% if form or s.section.complementary_information %}
                    </div>
                    {% endif %}
                                    {% endif %} {# has_complementary_information #}
                {% if forloop.first == False%}
                                </div>
                {% endif %}
                {% if forloop.last%}
                     {% if forloop.counter > 1 %}
                            </div>
                        </div>
                     {% endif %}
                    </div>
                {% endif %}
            {% endfor %}
        {% endfor %}
        {% if form %}
            <div class="row">
              <input class="btn btn-default btn-lg" type="submit" value="Save">
            </div>
        {% endif %}
        </div>
  {% if form %}
    </form>
  {% endif %}
</div>
{% endblock content %}

{% block custom_bottom_script %}
    <script type="text/javascript">
    $('#saveModal').on('shown.bs.modal', function (event) {
        var element=event.target;
        setTimeout(function () {
            $(element).modal('hide');
        }, 20000);
    });
    var frm = $('#main-form');
    frm.submit(function () {
        var formDataArray = frm.serializeArray();
        //custom tinyMCE textarea serialization
        $('textarea').each(function (index,e) {
            var ed = tinymce.get(e.id);
            if (ed) //only textarea with tinyMCE widget
            {
                for (var i=0;i < formDataArray.length;i++)
                {
                    if (formDataArray[i].name==e.name)
                    {
                        formDataArray[i].value = ed.getContent();
                        break;
                    }
                }
            }
         });
        var formData = $.param(formDataArray);
        $.ajax({
            type: frm.attr('method'),
            url: frm.attr('action'),
            data: formData,
            success: function (data) {
                $("#save-modal-alert").removeClass('alert-danger').addClass('alert-success');
                $("#save-modal-alert > p").html(data.message);
                $('#saveModal').modal('show');
            },
            error: function(data) {
                $("#save-modal-alert").removeClass('alert-success').addClass('alert-danger');
                if (data.responseJSON && 'error' in data.responseJSON) {
                    $("#save-modal-alert > p").html(data.responseJSON.error);
                    $.each(data.responseJSON.errors, function (field, error) {
                        $("#save-modal-alert > p").append('<BR>' + field + ' : ' + error)
                    });
                } else {
                    let errorMessage = `ERROR ${data.status} : ${data.statusText ? data.statusText : 'Unknown server error'} while saving`  
                    $("#save-modal-alert > p").html(errorMessage);
                }
                $('#saveModal').modal('show');
            }
        });
        return false;
    });
    </script>
    {% if form %}
        {{ form.media }}
    {% else %}
        {{ comment_form.media }}
    {% endif %}

    {% include "artefacts/dj_admin_related_object_lookups.html" %}
    {% include "artefacts/refresh-divs-script.html" %}
{% endblock custom_bottom_script %}
